package cn.com.qmth.examcloud.examwork.api;

import cn.com.qmth.examcloud.api.commons.CloudService;
import cn.com.qmth.examcloud.examwork.api.request.*;
import cn.com.qmth.examcloud.examwork.api.response.*;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年8月6日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public interface ExamCloudService extends CloudService {

    /**
     * 保存考试
     *
     * @param exam
     */
    SaveExamResp saveExam(SaveExamReq req);

    /**
     * 查询考试
     *
     * @param name
     * @return
     */
    GetExamResp getExam(GetExamReq req);

    /**
     * 查询考试
     *
     * @param name
     * @return
     */
    GetExamsByIdListResp getExamsByIdList(GetExamsByIdListReq req);

    /**
     * 设置考试属性配置
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    SetExamPropertyResp setExamProperty(SetExamPropertyReq req);

    /**
     * 获取考试属性配置
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    GetExamPropertyResp getExamProperty(GetExamPropertyReq req);

    /**
     * 获取考试属性配置集合
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    GetExamPropertyListResp getExamPropertyList(GetExamPropertyListReq req);

    /**
     * 获取正在进行的考试
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    GetOngoingExamListResp getOngoingExamList(GetOngoingExamListReq req);

    /**
     * 锁定考生
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    LockExamStudentsResp lockExamStudents(LockExamStudentsReq req);

    /**
     * 解锁考生
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    UnlockExamStudentsResp unlockExamStudents(UnlockExamStudentsReq req);

    /**
     * 查询考试
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    GetExamListResp getExamList(GetExamListReq req);

    /**
     * 查询考试的课程集合
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    GetExamCourseListResp getExamCourseList(GetExamCourseListReq req);

    GetExamCourseResp getExamCourseSetting(GetExamCourseReq req);

    /**
     * 查询考试课程的试卷类型集
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    GetExamCoursePaperTypeListResp getExamCoursePaperTypeList(GetExamCoursePaperTypeListReq req);

    /**
     * 统计考生数量
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    CountExamStudentResp countExamStudent(CountExamStudentReq req);

    /**
     * 获取考试机构列表
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    GetExamOrgListResp getExamOrgList(GetExamOrgListReq req);

    /**
     * 获取考生属性值集合
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    GetExamStudentPropertyValueListResp getExamStudentPropertyValueList(
            GetExamStudentPropertyValueListReq req);

    /**
     * 遍历考试
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    GetExamsResp getExams(GetExamsReq req);

    /**
     * 保存学生特殊设置
     *
     * @param req
     * @return
     * @author WANGWEI
     */
    SaveStudentSpecialSettingsResp saveStudentSpecialSettings(SaveStudentSpecialSettingsReq req);

    GetExamMapsResp getExamMaps(GetExamMapsReq req);

}
