package cn.com.qmth.examcloud.core.oe.student.api;

import cn.com.qmth.examcloud.api.commons.CloudService;
import cn.com.qmth.examcloud.core.oe.student.api.request.*;
import cn.com.qmth.examcloud.core.oe.student.api.response.*;

public interface ExamRecordDataCloudService extends CloudService {

    /**
     * 查询是否存在考试记录
     */
    ExistExamRecordDataResp existExamRecordData(ExistExamRecordDataReq req);

    GetExamRecordDataIdsResp getExamRecordDataIds(GetExamRecordDataIdsReq req);

    UpdateExamRecordDataBatchNumResp updateExamRecordDataBatchNum(UpdateExamRecordDataBatchNumReq req);

    /**
     * 计算活体检测结果
     *
     * @param req
     * @return
     */
    CalcFaceBiopsyResultResp calcFaceBiopsyResult(CalcFaceBiopsyResultReq req);

    /**
     * 计算考试分数
     *
     * @param req
     * @return
     */
    CalcExamScoreResp calcExamScore(CalcExamScoreReq req);

    /**
     * 获取旧活体检测结果
     *
     * @param req
     * @return
     */
    GetExamFaceLivenessVerifiesResp getExamFaceLivenessVerifies(GetExamFaceLivenessVerifiesReq req);

    /**
     * 获取新活检
     *
     * @param req
     * @return
     */
    GetFaceBiopsyResp getFaceBiopsy(GetFaceBiopsyReq req);

    GetExamRecordQuestionsResp getExamRecordQuestions(GetExamRecordQuestionsReq req);

    GetExamRecordPaperStructResp getExamRecordPaperStruct(GetExamRecordPaperStructReq req);

    /**
     * 交卷
     *
     * @param req
     * @return
     */
    HandInExamResp handInExam(HandInExamReq req);

    UpdateExamRecordStatusResp updateExamRecordStatus(UpdateExamRecordStatusReq req);

    /**
     * 获取考试记录数量
     *
     * @param req
     * @return
     */
    GetExamRecordNumResp getExamRecordNum(GetExamRecordNumReq req);

    /**
     * 更新部分考试数据
     *
     * @param req
     * @return
     */
    UpdatePartialExamRecordResp updatePartialExamRecord(UpdatePartialExamRecordReq req);

    CheckPaperInExamResp checkPaperInExam(CheckPaperInExamReq req);

}
